<script setup lang="ts">
import { useWeb3Modal } from '@web3modal/wagmi/vue';
import { useAccount } from 'use-wagmi';
import { computed } from 'vue';

import WaxIcon from '../icons/WaxIcon.vue';

import ArrowDownIcon from '@/components/icons/ArrowDownIcon.vue';
import HorseshoeIcon from '@/components/icons/HorseshoeIcon.vue';
import WalletBackgroundIcon from '@/components/icons/WalletBackgroundIcon.vue';
import WalletDropdownBackgroundIcon from '@/components/icons/WalletDropdownBackgroundIcon.vue';
import { useReferralLink } from '@/composables/useReferralLink';
import { shortenAddress } from '@/lib/address';
import { cn } from '@/lib/utils';
import { useUiNavbarStore } from '@/stores/ui/navbar';

const { open } = useWeb3Modal();
const { address, chain, isConnected } = useAccount();
const store = useUiNavbarStore();
const referralLink = useReferralLink();

const options = computed(() => {
  if (address.value) {
    if (chain.value) {
      return { value: shortenAddress(address.value), click: store.toggle } as const;
    }
    return { value: 'Wrong network', click: open({ view: 'Networks' }) } as const;
  }

  return { value: 'Connect Wallet', click: open({ view: 'Connect' }) } as const;
});

const copyReferralLink = () => {
  navigator.clipboard.writeText(referralLink.value);
};
</script>

<template>
  <div class="flex items-center gap-[20px]">
    <button class="relative w-[271px] h-[47px] text-background" @click="options.click">
      <div
        :class="
          cn('absolute w-full transition-all cursor-default', store.isOpen ? 'h-[201px]' : 'h-0')
        "
      >
        <WalletDropdownBackgroundIcon
          :class="
            cn('transition-all absolute left-0 top-[4px] right-0 w-full', !store.isOpen && 'h-0')
          "
        />
        <WaxIcon v-if="store.isOpen" v-motion-fade class="absolute bottom-0 right-[5px]" />
        <div
          v-if="store.isOpen"
          v-motion-fade
          class="absolute bottom-[25%] left-[17%] flex flex-col gap-[20px]"
        >
          <button class="text-[20px] font-bold text-[#6A6346]" @click="copyReferralLink">
            copy referral link
          </button>
          <button
            class="text-[20px] font-bold text-[#6A6346]"
            @click="() => open({ view: 'Account' })"
          >
            change wallet
          </button>
        </div>
      </div>
      <WalletBackgroundIcon class="absolute inset-0" />
      <div class="flex items-center gap-[18px] relative justify-center">
        <span class="text-background text-[24px] font-bold">{{ options.value }}</span>
        <ArrowDownIcon
          v-if="isConnected"
          v-motion-fade
          :class="cn('transition-all', store.isOpen && 'rotate-180')"
        />
      </div>
    </button>
    <HorseshoeIcon :class="cn('transition-all', isConnected && 'rotate-180')" />
  </div>
</template>
